#!/usr/local/bin/wish -f
# Copyright 1996 J.P.M. de Vreught

set current_file ""
set current_partner ""
set current_phase ""
set current_move ""
set current_code ""
set current_subcode ""
set current_argument ""
set current_subargument ""

set ab_partner(Client) 1
set ab_partner(Operator) 2

set ab_phase(Bye) B
set ab_phase(Greeting) G
set ab_phase(Information) I
set ab_phase(Pause) P
set ab_phase(Query) Q
set ab_phase(Subquery) S

set ab_move(Acknowledgement) Ack
set ab_move(Alignment) Ali
set ab_move(Bye) Bye
set ab_move(Check) Che
set ab_move(Clarification) Cla
set ab_move(Greeting) Gre
set ab_move(Other) Oth
set ab_move(Pause) Pau
set ab_move(Question) Que
set ab_move(Reconfirmation) Rec
set ab_move(Statement) Sta

set ab_code(Acknowledge) Ack
set ab_code(Announce) Ann
set ab_code(Break) Bre
set ab_code(Bye) Bye
set ab_code(Garbage) Gar
set ab_code(Location) Loc
set ab_code(Other) Oth
set ab_code(Personal) Per
set ab_code(Price) Pr
set ab_code(Ready) Rea
set ab_code(Route_Information) RI
set ab_code(Time) Tm
set ab_code(Timetable) Tt

set ab_subcode(Amount) Amo
set ab_subcode(Announce) Ann
set ab_subcode(Arrival_Place) ArP
set ab_subcode(Arrival_Time) ArT
set ab_subcode(Company) Com
set ab_subcode(Connection) Con
set ab_subcode(Connection_Type) CoT
set ab_subcode(Daily_Schedule) DaS
set ab_subcode(Departure_Place) DeP
set ab_subcode(Departure_Time) DeT
set ab_subcode(Direction) Dir
set ab_subcode(Foreign_Information) FoI
set ab_subcode(Global_Time) GlT
set ab_subcode(Goodbye) Goo
set ab_subcode(Irregular_Service) IrS
set ab_subcode(Mumbling) Mum
set ab_subcode(Name) Nam
set ab_subcode(Negative) Neg
set ab_subcode(Nonverbal) Non
set ab_subcode(Opening_Hours) OpH
set ab_subcode(Other_Information) OtI
set ab_subcode(Positive) Pos
set ab_subcode(Regular_Service) ReS
set ab_subcode(Regular_Ticket) ReT
set ab_subcode(Repetition) Rep
set ab_subcode(Residence) Res
set ab_subcode(Return_Grace) ReG
set ab_subcode(Season_Ticket) SeT
set ab_subcode(Stopover) Sto
set ab_subcode(Telephone_Number) TeN
set ab_subcode(Thanks) Tha
set ab_subcode(Transport_Type) TrT
set ab_subcode(Traveling_Time) TTm
set ab_subcode(Verbal) Ver
set ab_subcode(Via) Via

set counter 1

wm title . "OVR coder"

frame .file
frame .speech_parts
frame .coding
frame .transliteration
pack .file .speech_parts .coding .transliteration -fill x -expand true

button .file.exit -text "Exit" -command exit 
pack .file.exit -side right

proc Load_File {} {
	global counter current_file transliteration
	set current_file ""
	entry .file.name.ask -textvariable current_file
	pack .file.name.ask
	bind .file.name.ask <Return> {
		set counter 1
		set input [open $current_file]
		$transliteration config -state normal
		$transliteration delete 1.0 end
		$transliteration insert end [read $input]
		$transliteration config -state disabled
		close $input
		destroy .file.name.ask
		.file.name config -text $current_file
	}
	tkwait window .file.name.ask
}

proc New_Number {} {
	global counter coding
	$coding insert insert " $counter"
	incr counter
}

proc Header {} {
	global transliteration coding
	regsub {\*+} [$transliteration get 1.0 end] "" header
	regsub "\n" $header "" header
	regsub {\*+.*} $header "" header
	$coding insert insert "Header(\n"
	$coding insert insert $header
	$coding insert insert ")\n"
}

proc Trailer {} {
	global transliteration coding
	regsub {\*+[^*]*\*+[^*]*\*+} [$transliteration get 1.0 end] "" trailer
	regsub "\n" $trailer "" trailer
	regsub {\*+} $trailer "" trailer
	regsub "\n*$" $trailer "" trailer
	$coding insert insert "\n\nTrailer(\n"
	$coding insert insert $trailer
	$coding insert insert "\n)"
}

proc Save_File {} {
	global current_file coding
	regsub {([^\.]*).txt} $current_file {\1.cod} file
	set output [open $file w]
	puts -nonewline $output [$coding get 1.0 end]
	close $output
	$coding delete 1.0 end
}

button .file.load -text "Load" -command Load_File
button .file.header -text "Header" -command Header
button .file.number -text "Number" -command New_Number
button .file.trailer -text "Trailer" -command Trailer
button .file.save -text "Save" -command Save_File
label .file.label -text "File:"
label .file.name -text $current_file
pack .file.load .file.header .file.number .file.trailer .file.save -side left
pack .file.label -side left
pack .file.name -side left -padx 10

scrollbar .coding.scrollbar \
	-command { .coding.text yview } \
	-orient vertical
set coding [text .coding.text \
	-setgrid true -wrap word -width 80 -height 6 \
	-yscrollcommand { .coding.scrollbar set }]
focus .coding.text
pack .coding.scrollbar -side left -fill y -expand true
pack .coding.text -side left -fill y -expand true

scrollbar .transliteration.scrollbar \
	-command { .transliteration.text yview } \
	-orient vertical
set transliteration [text .transliteration.text \
	-setgrid true -wrap word -width 80 -height 12 \
	-yscrollcommand { .transliteration.scrollbar set }]
pack .transliteration.scrollbar -side left -fill y -expand true
pack .transliteration.text -side left -fill y -expand true

set partners_phases [frame .speech_parts.partners_phases]
set moves [frame .speech_parts.moves]
set codes [frame .speech_parts.codes]
set subcodes [frame .speech_parts.subcodes]
set arguments [frame .speech_parts.arguments]
set subarguments [frame .speech_parts.subarguments]
pack $partners_phases $moves $codes $subcodes $arguments $subarguments \
	-side left -fill x -anchor n

frame $subcodes.tmp
frame $arguments.tmp
frame $subarguments.tmp
pack $subcodes.tmp $arguments.tmp $subarguments.tmp \
	-side left -fill x -anchor n

set partners [frame $partners_phases.partners]
set phases [frame $partners_phases.phases]
pack $partners $phases -fill y

proc Partner { partner } {
	global coding ab_partner
	$coding insert insert "\n$ab_partner($partner):"
}

proc Widget_Partners { parent args } {
	global current_partner
	label $parent.label -text "Partners"
	pack $parent.label -anchor w
	set i 0
	foreach item $args {
		if {$i == 0} {
			set current_partner $item
		}
		radiobutton $parent.$i -variable current_partner \
			-text $item -value $item \
			-command [list Partner $item]
		pack $parent.$i -anchor w
		incr i
	}
}

Widget_Partners $partners Client Operator

proc Widget_Phases { parent args } {
	global current_phase
	label $parent.label -text "Phases"
	pack $parent.label -anchor w
	set i 0
	foreach item $args {
		if {$i == 0} {
			set current_phase $item
		}
		radiobutton $parent.$i -variable current_phase \
			-text $item -value $item
		pack $parent.$i -anchor w
		incr i
	}
}

Widget_Phases $phases Bye Greeting Information Pause Query Subquery

proc Move { move } {
	global current_phase coding ab_phase ab_move
	$coding insert insert " $ab_move($move)"
	$coding insert insert "("
	$coding insert insert $ab_phase($current_phase)
	$coding insert insert ",\[\],\[\])"
	$coding mark set insert "insert -5 chars"
}

proc Widget_Moves { parent args } {
	global current_move
	label $parent.label -text "Moves"
	pack $parent.label -anchor w
	set i 0
	foreach item $args {
		if {$i == 0} {
			set current_move $item
		}
		radiobutton $parent.$i -variable current_move \
			-text $item -value $item \
			-command [list Move $item]
		pack $parent.$i -anchor w
		incr i
	}
}

Widget_Moves $moves \
	Acknowledgement Alignment Bye Check Clarification Greeting Other \
	Pause Question Reconfirmation Statement

proc Subargument { subargument } {
	global coding
	$coding insert insert " $subargument"
	set medium { Bus_Ticket Other Train_Bus_Ticket Train_Ticket }
	if {[lsearch -exact $medium $subargument] >= 0} {
		$coding insert insert "()"
		$coding mark set insert "insert -1 chars"
	}
}

proc Widget_Subarguments { parent title args } {
	global current_subargument
	label $parent.label -text "Subargument"
	label $parent.title -text "for $title"
	pack $parent.label $parent.title -anchor w
	set i 0
	foreach item $args {
		if {$i == 0} {
			set current_subargument $item
		}
		radiobutton $parent.$i -variable current_subargument \
			-text $item -value $item \
			-command [list Subargument $item]
		pack $parent.$i -anchor w
		incr i
	}
}

proc Setup_Subarguments { argument } {
	global subarguments
	destroy $subarguments.tmp
	frame $subarguments.tmp
	pack $subarguments.tmp -side left -fill x -anchor n
	switch -exact -- $argument {
		Date {
			Widget_Subarguments $subarguments.tmp Date \
				Other Today Tomorrow Weekdays Weekend
		}
		Monthly {
			Widget_Subarguments $subarguments.tmp Monthly \
				Bus_Ticket Train_Bus_Ticket Train_Ticket
		}
		Part_of_Day {
			Widget_Subarguments $subarguments.tmp Part_of_Day \
				Afternoon Evening Morning Night

		}
		Weekly {
			Widget_Subarguments $subarguments.tmp Weekly \
				Bus_Ticket Train_Bus_Ticket Train_Ticket
		}
		Yearly {
			Widget_Subarguments $subarguments.tmp Yearly \
				Bus_Ticket Train_Bus_Ticket Train_Ticket
		}
	}
}

proc Argument { argument } {
	global coding
	$coding insert insert " $argument"
	set medium { About After Before Between Bus_Tram Bus_Fare Bus_Stop \
		City Costs Evening_Trip Exact Explicit First_Class \
		Five_Returns Frequency House Interliner Platform Reduction \
		Return Second_Class Single Station Street Weekend_Trip }
	set long { Date Monthly Part_of_Day Weekly Yearly }
	if {[lsearch -exact $long $argument] >= 0} {
		$coding insert insert "(\[\])"
		$coding mark set insert "insert -2 chars"
	} elseif {[lsearch -exact $medium $argument] >= 0} {
		$coding insert insert "()"
		$coding mark set insert "insert -1 chars"
	}
	Setup_Subarguments $argument
}

proc Widget_Arguments { parent title args } {
	global current_argument
	label $parent.label -text "Argument"
	label $parent.title -text "for $title"
	pack $parent.label $parent.title -anchor w
	set i 0
	foreach item $args {
		if {$i == 0} {
			set current_argument $item
		}
		radiobutton $parent.$i -variable current_argument \
			-text $item -value $item \
			-command [list Argument $item]
		pack $parent.$i -anchor w
		incr i
	}
}

proc Setup_Arguments { subcode } {
	global arguments
	destroy $arguments.tmp
	frame $arguments.tmp
	pack $arguments.tmp -side left -fill x -anchor n
	switch -exact -- $subcode {
		Amount {
			Widget_Arguments $arguments.tmp Amount \
				Costs First_Class Second_Class
		}
		Arrival_Place {
			Widget_Arguments $arguments.tmp Arrival_Place \
				Bus_Stop City House Platform Station Street \
				Unspecified
		}
		Arrival_Time {
			Widget_Arguments $arguments.tmp Arrival_Time \
				About After Before Between Exact Unspecified
		}
		Connection {
			Widget_Arguments $arguments.tmp Connection \
				First Last Next Next_Available Previous
		}
		Connection_Type {
			Widget_Arguments $arguments.tmp Connection_Type \
				Direct Indirect Nonstop Stop
		}
		Daily_Schedule {
			Widget_Arguments $arguments.tmp Daily_Schedule \
				Explicit Frequency Next_Hour Previous_Hour \
				Unspecified
		}
		Departure_Place {
			Widget_Arguments $arguments.tmp Departure_Place \
				Bus_Stop City House Platform Station Street \
				Unspecified
		}
		Departure_Time {
			Widget_Arguments $arguments.tmp Departure_Time \
				About After Before Between Exact Unspecified
		}
		Direction {
			Widget_Arguments $arguments.tmp Direction \
				Bus_Stop City House Platform Station Street \
				Unspecified
		}
		Global_Time {
			Widget_Arguments $arguments.tmp Global_Time \
				Date Part_of_Day
		}
		Irregular_Service {
			Widget_Arguments $arguments.tmp Irregular_Service \
				Calamity Extra_Service
		}
		Repetition {
			Widget_Arguments $arguments.tmp Repetition \
				Complete Partial
		}
		Regular_Service {
			Widget_Arguments $arguments.tmp Regular_Service \
				Alternative New_Service Old_Service
		}
		Regular_Ticket {
			Widget_Arguments $arguments.tmp Regular_Ticket \
				Bus_Fare Evening_Trip Five_Returns \
				Reduction Return Single Weekend_Trip
		}
		Season_Ticket {
			Widget_Arguments $arguments.tmp Season_Ticket \
				Monthly Weekly Yearly
		}
		Stopover {
			Widget_Arguments $arguments.tmp Stopover \
				Long_Stop Medium_Stop Reference Short_Stop
		}
		Transport_Type {
			Widget_Arguments $arguments.tmp Transport_Type \
				Bus_Tram Ferry Interliner Subway Train \
				Train_Taxi Walking
		}
		Via {
			Widget_Arguments $arguments.tmp Via \
				Bus_Stop City House Platform Station Street \
				Unspecified
		}
	}
	Setup_Subarguments ""
}

proc Subcode { subcode } {
	global coding ab_subcode
	$coding insert insert " $ab_subcode($subcode)"
	set short { Company Goodbye Mumbling Name Negative Nonverbal \
		 Positive Residence Return_Grace Thanks Verbal }
	set medium { Foreign_Information Opening_Hours \
		Other_Information Telephone_Number Traveling_Time }
	if {[lsearch -exact $medium $subcode] >= 0} {
		$coding insert insert "()"
		$coding mark set insert "insert -1 chars"
	} elseif {[lsearch -exact $short $subcode] < 0} {
		$coding insert insert "(\[\])"
		$coding mark set insert "insert -2 chars"
	}
	Setup_Arguments $subcode
}

proc Widget_Subcodes { parent title args } {
	global current_subcode
	label $parent.label -text "Subcodes"
	label $parent.title -text "for $title"
	pack $parent.label $parent.title -anchor w
	set i 0
	foreach item $args {
		if {$i == 0} {
			set current_subcode $item
		}
		radiobutton $parent.$i -variable current_subcode \
			-text $item -value $item \
			-command [list Subcode $item]
		pack $parent.$i -anchor w
		incr i
	}
}

proc Setup_Subcodes { code } {
	global subcodes
	destroy $subcodes.tmp
	frame $subcodes.tmp
	pack $subcodes.tmp -side left -fill x -anchor n
	switch -exact -- $code {
		Acknowledge {
			Widget_Subcodes $subcodes.tmp Acknowledge \
				Negative Positive Repetition
		}
		Break {
			Widget_Subcodes $subcodes.tmp Break \
				Mumbling Repetition
		}
		Bye {
			Widget_Subcodes $subcodes.tmp Bye \
				Goodbye Return_Grace Thanks
		}
		Garbage {
			Widget_Subcodes $subcodes.tmp Garbage \
				Nonverbal Verbal
		}
		Location {
			Widget_Subcodes $subcodes.tmp Location \
				Arrival_Place Departure_Place Direction Via
		}
		Other {
			Widget_Subcodes $subcodes.tmp Other \
				Foreign_Information Opening_Hours \
				Other_Information Telephone_Number
		}
		Personal {
			Widget_Subcodes $subcodes.tmp Personal \
				Company Name Residence
		}
		Price {
			Widget_Subcodes $subcodes.tmp Price \
				Amount Regular_Ticket Season_Ticket
		}
		Route_Information {
			Widget_Subcodes $subcodes.tmp Route_Information \
				Connection_Type Stopover Transport_Type \
				Traveling_Time
		}
		Time {
			Widget_Subcodes $subcodes.tmp Time \
				Arrival_Time Connection Departure_Time \
				Global_Time
		}
		Timetable {
			Widget_Subcodes $subcodes.tmp Timetable \
				Daily_Schedule Irregular_Service \
				Regular_Service
		}
	}
	Setup_Arguments ""
}

proc Code { code } {
	global coding ab_code
	$coding insert insert " $ab_code($code)"
	set short { Announce Ready }
	if {[lsearch -exact $short $code] < 0} {
		$coding insert insert "(\[\])"
		$coding mark set insert "insert -2 chars"
	}
	Setup_Subcodes $code
}

proc Widget_Codes { parent args } {
	global current_code
	label $parent.label -text "Codes"
	pack $parent.label -anchor w
	set i 0
	foreach item $args {
		if {$i == 0} {
			set current_code $item
		}
		radiobutton $parent.$i -variable current_code \
			-text $item -value $item \
			-command [list Code $item]
		pack $parent.$i -anchor w
		incr i
	}
}

Widget_Codes $codes \
	Acknowledge Announce Break Bye Garbage Location Other Personal \
	Price Ready Route_Information Time Timetable
